#include "simulation.h"
#include "random.h"
#include<time.h>
//-------------------------------SHO demo-------------------------------- 
class TService;

CHead     *Queue[2];
TService  *Service;                              

// Statistika
double MaximalniDobaCekani[2];
double CelkovaDobaCekani[2];
int PocetCekani[2];

int MaximumCekajicich[2];
int CelkoveCekajicich[2];

 int QMax = 2;


class TRequest : public CProcess                 // request in the queueing system
{                                                
	virtual void Run();                            // request's behaviour
	public: 
 	int Id; // cislo opilce
	int DruhHosta; // 0-stamgast, 1-ostatni
	int PocetPiv; // vypita piva
};


class TService : public CProcess                 // process servicing requests
{                                                 
  virtual void Run();                            // service's behaviour
};

void TRequest::Run()                           
{
	double t = Time ();
  printf("Host %d zada %d. pivo v case %f s\n", Id, PocetPiv + 1, t);  
              // scheduling incoming of next request
  if (Queue[DruhHosta]->Empty()) {                            // if the queue is empty 
    Into(Queue[DruhHosta]);                                  // inserting request into queue
    printf("Host %d probouzi spiciho barmana....\n", Id);             
    Service->ActivateAt(Time ());                  // waking up service process
  } else {
    printf("Je tu %d pozadavku o pivo, radim...\n", Queue[DruhHosta]->Cardinal());
    Into(Queue[DruhHosta]);                                  // ranking the request process to the end of the queue
  }
  printf("Host %d ceka na pivo... \n", Id);  
  
  // Stat
  int c = Queue[DruhHosta] -> Cardinal();
  if (c > MaximumCekajicich[DruhHosta])
	MaximumCekajicich[DruhHosta] = c;

  PocetCekani[DruhHosta]++;
  CelkoveCekajicich[DruhHosta]+=c;
  
  Passivate();                                      // waiting for the finishing the service
  
  // Stat
  t = Time() - t;
  if (t > MaximalniDobaCekani[DruhHosta])
	MaximalniDobaCekani[DruhHosta] = t;

  CelkovaDobaCekani[DruhHosta]+=t;
  

  
	
  
  	TRequest *r;
	r = (new TRequest);
	r->Id = Id;		
	r->PocetPiv = PocetPiv + 1;
	r->DruhHosta = DruhHosta;
	double d = negexp((double)1/(30 * 60));
//	double d = 30 * 60; // D???
	r->ActivateDelay(d);
	printf("Host %d zacina pit sve %d. pivo v case %f, po dobu %f\n", Id, PocetPiv + 1, Time (), d); 
  
}

void TService::Run()                               
{
  CProcess* P;                                       // temp. variable
//  int DruhHosta = 0;
  while(true) {
	
	  if (Queue[0]->Empty() & Queue[1]->Empty()) {
       printf("Vsichni maji piva, jdu spat ... \n");
       Passivate();                                 // service is waiting for incoming requests
     } else {
       printf("Barman se probudil v case %f\n",Time ());     // in the queue, there is at least one request
       for (int DruhHosta = 0; DruhHosta < QMax; DruhHosta++) {
		   if (!Queue[DruhHosta]->Empty())  {
			P=(CProcess*)Queue[DruhHosta]->First();                
			P->Out();                                      // removing the request from the queue
			Hold(randint(60, 120));                             // servicing time (mean value 50 )
			P->ActivateAt (Time());                        // executing request
			printf("Barman sel spat v case %f\n",Time ());
			break;
		   }
	   }
     }

  }
}
/*----------------------------------------------*/
void CSimulation::Run()                          // main process
{
  printf("--- Demonstration of SIMULATION module -- time %f\n", Time());

	for (int i = 0; i < QMax; i++)
	{
		MaximalniDobaCekani[i] = 0;
		CelkovaDobaCekani[i] = 0;
		MaximumCekajicich[i] = 0;
		PocetCekani[i] = 0;
		CelkoveCekajicich[i] = 0;
	}


  srand( (unsigned)time( NULL ) );               // inicialization on random number generator
  Service = new TService();                      // creating service process
	
	for (int i = 0; i < QMax; i++)
	{
	  Queue[i]  = new CHead();                          // creating instance of queue
	}
  

  for (int i = 0; i < 15; i++)
  {
	TRequest *r;
	r = (new TRequest);
	r->Id = i;	
	if (i < 5)
		r->DruhHosta = 0;
	else
		r->DruhHosta = 1;
	r->PocetPiv = 0; // jsem vysusen
	r->ActivateAt(Time () + 100 * i);           // creating and scheduling 1st request
  }

  Hold(10 * 60 * 60);                                     // waiting before simulation end
//  Hold(10 * 60 * 60);                                     // waiting before simulation end
	for (int i = 0; i < QMax; i++)
	{
		if (PocetCekani[i] > 0)
		  printf("* prumerna a maximalni doba cekani na pivo je %f %f \n", CelkovaDobaCekani[i] / PocetCekani[i], MaximalniDobaCekani[i]);
	}
	for (int i = 0; i < QMax; i++)
	{
	  if (PocetCekani[i] > 0)
		  printf("* prumerne a maximalne najednou cekalo na pivo %f %d \n", (double)CelkoveCekajicich[i] / PocetCekani[i], MaximumCekajicich[i]);
	}

printf("* v dobe zaviracky nevyrizeno %ld obednavek\n", Queue[0] -> Cardinal() + Queue[1] -> Cardinal() );
  printf("Hospoda zavrena v case %f.\n\n", Time ());
  
}; 